<script lang="ts">
  import { getCard, getRank, getSuit } from "../serverUtils";
  import SuitIcon from "../icons/SuitIcon.svelte";
  import Art from "./CardArt.svelte";
  import { cardTitle, cardValue, suitClass } from "./cardUtils";

  export let card: Card;
  export let inline: boolean = false;

  $: suit = getSuit(card);
  $: suitCls = suitClass(suit);
  $: value = cardValue(card);
  $: title = cardTitle(card);

  function cardDescription(card: Card): String | null {
    switch (getRank(card)) {
      case "11":
        return "When you lead this, if your opponent has a card of this suit, they must play either the 1 of this suit or their highest ranked card of this suit.";
      case "9":
        return "When determining the winner of a trick with only one 9, treat the 9 as if it were in the trump suit.";
      case "7":
        return "The winner of the trick receives 1 point for each 7 in the trick.";
      case "5":
        return "When you play this, draw 1 card. Then discard any 1 card to the bottom of the deck (face down).";
      case "3":
        return "When you play this, you may exchange the trump card with a card from your hand.";
      case "1":
        return "If you play this and lose the trick, you lead the next trick.";
      default:
        return null;
    }
  }
</script>

{#if inline}
  <span class={suitCls}>
    <span class="inline value">{value}</span>
    <SuitIcon {suit} />
  </span>
{:else}
  <div class="wrapper shadow">
    <div class="inner {suitCls}">
      <div class="value">{value}</div>
      {#if title}
        <div class="title">{title}</div>
      {/if}
      <div class="suit">
        <SuitIcon {suit} />
      </div>
    </div>
    <div class="art {suitCls}">
      <Art {card} />
    </div>

    {#if cardDescription(card)}
      <div class="description">
        <div class="ribbon-wrapper">
          <div class="ribbon">
            <div class="ribbon-content">
              {#if getRank(card) === "11"}
                When you lead this, if your opponent has a
                <span class={suitCls}>
                  <SuitIcon {suit} />
                </span>
                , they must play either the
                <svelte:self inline card={getCard("1", suit)} />
                or their highest
                <span class={suitCls}>
                  <SuitIcon {suit} />
                </span>
                .
              {:else}
                {cardDescription(card)}
              {/if}
            </div>
          </div>
        </div>
      </div>
    {/if}
  </div>
{/if}

<style>
  .wrapper {
    background-color: linen;
    position: relative;
    width: 10em;
    height: 14em;
    border-radius: 7% / 5%;
    border: 0.05em solid lightgray;
  }
  .inner {
    font-size: 0.5em;
    position: absolute;
    top: 0;
    left: 0;
    bottom: 0;
    right: 0;
    display: grid;
    align-content: center;
    grid-template-columns: 25% 75%;
    grid-template-rows: 15% 5% 15% 65%;

    color: grey;
  }
  .value {
    font-family: Domine;
    font-size: 4em;
    text-align: center;

    grid-column-start: 1;
    grid-column-end: 2;
    grid-row-start: 1;
    grid-row-end: 2;
  }
  .value.inline {
    color: grey;
    font-size: 1em;
    margin-left: 0.2em;
    display: inline-block;
    transform: scale(1.33);
  }
  .title {
    color: rgb(22, 22, 22);
    font-size: 120%;
    text-align: center;
    font-family: "PT Sans Narrow";

    grid-column-start: 1;
    grid-column-end: 2;
    grid-row-start: 2;
    grid-row-end: 3;
  }
  .suit {
    font-size: 2.5em;
    text-align: center;

    grid-column-start: 1;
    grid-column-end: 2;
    grid-row-start: 3;
    grid-row-end: 4;
  }

  .suit-a {
    filter: grayscale(100%) sepia(100%) hue-rotate(180deg) saturate(200%)
      brightness(100%);
  }
  .suit-b {
    filter: grayscale(100%) sepia(100%) hue-rotate(210deg) saturate(200%)
      brightness(95%);
  }
  .suit-c {
    filter: grayscale(100%) sepia(100%) hue-rotate(-25deg) saturate(220%)
      brightness(95%);
  }

  .art {
    position: absolute;
    top: 1em;
    bottom: 1em;
    left: 2.25em;
    right: 2.25em;
  }

  .description {
    font-family: Domine;
    font-size: 0.45em;

    left: 10%;
    right: 10%;
    bottom: 0;
    position: absolute;
    text-align: center;
  }
  .ribbon-wrapper {
    position: relative;
    z-index: 0;
  }
  .ribbon {
    position: relative;
    background: #f0d6b9;
    border-top-left-radius: 0.5em;
    border-top-right-radius: 0.5em;
    min-height: 6em;
    display: flex;
    align-items: center;

    text-align: center;
    padding: 1em;
    margin: 2em auto 3em;
  }
  .ribbon:before,
  .ribbon:after {
    content: "";
    position: absolute;
    display: block;
    bottom: -1em;
    border-left: 1.5em solid #dac2a7;
    border-right: 1.5em solid #dac2a7;
    border-top: 3em solid #dac2a7;
    border-bottom: 3em solid #dac2a7;
    z-index: -1;
  }
  .ribbon:before {
    left: -1em;
    border-right-width: 0.5em;
    /* border-left-color: transparent; */
  }
  .ribbon:after {
    right: -1em;
    border-left-width: 0.5em;
    /* border-right-color: transparent; */
  }
  .ribbon .ribbon-content:before,
  .ribbon .ribbon-content:after {
    content: "";
    position: absolute;
    display: block;
    border-style: solid;
    border-color: #a3917d transparent transparent transparent;
    bottom: -1em;
  }
  .ribbon .ribbon-content:before {
    left: 0;
    border-width: 1em 0 0 1em;
  }
  .ribbon .ribbon-content:after {
    right: 0;
    border-width: 1em 1em 0 0;
  }
</style>
